/*
 * Copyright 1996-2002 netFluid Technology Ltd
 *
 * Goldwater is written and maintained by netFluid Technology Ltd.
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * $Revision: 1.1 $  $Date: 2003/01/11 12:40:09 $
 * ---------------------------------------------------------------------------
 */
#ifndef XL_LOGGING_H
#define XL_LOGGING_H

#include <phlib/xl_types.h>
#include <phlib/xl_string.h>

struct loginfo {
  /* - Statics - */
  int  fd;
  /* - Dynamics - */
  int  trlev;        /* Trace level 0..9          */
  CString rambuffer; /* Special buffer for log info when we've no fd */
  CString Cache;
};

typedef long TraceHandle;

extern TraceHandle DefLogHand;

/* Prototypes */
RetValue    into_cache   ( struct loginfo *logblk, char *data );
TraceHandle init_ulflog  ( int trlev, long csize, char *logfile );
RetValue    reopen_ulflog( TraceHandle th, char *logfile );
RetValue    finish_ulflog( TraceHandle lhand );
void        ulflog       ( TraceHandle lhand, int trlev, char *text );
void        ulflogf      ( TraceHandle lhand, int trlev, char *f, ... );
void        flush_ulflog();
void        set_ulflog_level( TraceHandle th, int level );
void        set_ulflog_cache_size( TraceHandle th, int cachesize );
#endif

/* end */
